# Lab 1

## Assignment 1

2. Comment: The confusion matrix looks good. Hardest for 1, 7, 8 and 9
   (especially 9).

   Confusion matrices:

   - **Training**:
     | | 0 | 1 | 2 | 3 | 4 | 5 | 6 | 7 | 8 | 9 |
     | ----- | --- | --- | --- | --- | --- | --- | --- | --- | --- | --- |
     | **0** | 202 | 0 | 0 | 0 | 0 | 0 | 0 | 0 | 0 | 0 |
     | **1** | 0 | 179 | 11 | 0 | 0 | 0 | 0 | 1 | 1 | 3 |
     | **2** | 0 | 1 | 190 | 0 | 0 | 0 | 0 | 1 | 0 | 0 |
     | **3** | 0 | 0 | 0 | 185 | 0 | 1 | 0 | 1 | 0 | 1 |
     | **4** | 1 | 3 | 0 | 0 | 159 | 0 | 0 | 7 | 1 | 4 |
     | **5** | 0 | 0 | 0 | 1 | 0 | 171 | 0 | 1 | 0 | 8 |
     | **6** | 0 | 2 | 0 | 0 | 0 | 0 | 190 | 0 | 0 | 0 |
     | **7** | 0 | 3 | 0 | 0 | 0 | 0 | 0 | 178 | 1 | 0 |
     | **8** | 0 | 10 | 0 | 2 | 0 | 0 | 2 | 0 | 188 | 2 |
     | **9** | 1 | 3 | 0 | 5 | 2 | 0 | 0 | 3 | 3 | 183 |

   - **Test**:
     | | 0 | 1 | 2 | 3 | 4 | 5 | 6 | 7 | 8 | 9 |
     | ----- | --- | --- | --- | --- | --- | --- | --- | --- | --- | --- |
     | **0** | 77 | 0 | 0 | 0 | 1 | 0 | 0 | 0 | 0 | 0 |
     | **1** | 0 | 81 | 2 | 0 | 0 | 0 | 0 | 0 | 0 | 3 |
     | **2** | 0 | 0 | 98 | 0 | 0 | 0 | 0 | 0 | 3 | 0 |
     | **3** | 0 | 0 | 0 | 107 | 0 | 2 | 0 | 0 | 1 | 1 |
     | **4** | 0 | 0 | 0 | 0 | 94 | 0 | 2 | 6 | 2 | 5 |
     | **5** | 0 | 1 | 1 | 0 | 0 | 93 | 2 | 1 | 0 | 5 |
     | **6** | 0 | 0 | 0 | 0 | 0 | 0 | 90 | 0 | 0 | 0 |
     | **7** | 0 | 0 | 0 | 1 | 0 | 0 | 0 | 111 | 0 | 0 |
     | **8** | 0 | 7 | 0 | 1 | 0 | 0 | 0 | 0 | 70 | 0 |
     | **9** | 0 | 1 | 1 | 1 | 0 | 0 | 0 | 1 | 0 | 85 |

   Misclassification errors:

   - $E_{\text{mis,train}} = 0.04500262$
   - $E_{\text{mis,test}} =0.05329154$

3. Comment: The easy cases were easy to recognize visually while the
   hard ones were hard to recognize.

4. The complexity is the highest when $k$ is the lowest and decreases
   when we increase $k$ (as seen in the graph when the training error
   increases with an increasing $k$). Optimal $k$ when the validation
   error is minimum, when $k = 3$.

   ![Misclassification rate depending on k](./figures/assignment1-4.png)

   Formula: $$R(Y, \hat{Y}) = \frac{1}{N} \sum_{i=1}^{N} I(Y_i \neq \hat{Y}_i)$$

   Test error ($k = 3$): $E_{\text{mis,test}} = 0.02403344$. Higher
   than the training error but slightly lower than the validation error.
   According to us it is a pretty good model considering that it
   correct $\approx 98 \%$ of times.

5. Optimal $k = 6$, when the average cross-entropy loss is the lowest.
   Average cross-entropy loss takes probabilities in the prediction
   into account which is a better represntation of a model with
   multionmial distribution. An important aspect is that we can
   determina how wrong a classification is, not just wether it is
   wrong or not.

   ![Average cross-entropy loss depending on k](./figures/assignment1-5.png)

   Formula: $$R(Y, \hat{p}(Y)) = - \frac{1}{N} \sum_{i=1}^{N} \sum_{m=1}^{M} I(Y_i = C_m) \log \hat{p}(Y_i = C_m)$$

## Assignment 2

2. In the estimation summary shown bellow we can see our features
   ordered by significance. Here DFA is the most significant.

   Estimation summary:

   | Coefficient   | Estimate   | Std. Error | t value | Pr(>\|t\|) |
   | ------------- | ---------- | ---------- | ------- | ---------- |
   | DFA           | -0.280318  | 0.020136   | -13.921 | < 2e-16    |
   | PPE           | 0.226467   | 0.032881   | 6.887   | 6.70e-12   |
   | HNR           | -0.238543  | 0.036395   | -6.554  | 6.41e-11   |
   | Shimmer.APQ11 | 0.305546   | 0.061236   | 4.990   | 6.34e-07   |
   | Jitter.Abs.   | -0.169609  | 0.040805   | -4.157  | 3.31e-05   |
   | NHR           | -0.185387  | 0.045567   | -4.068  | 4.84e-05   |
   | Shimmer.APQ5  | -0.387507  | 0.113789   | -3.405  | 0.000668   |
   | Shimmer       | 0.592436   | 0.205981   | 2.876   | 0.004050   |
   | RPDE          | 0.004068   | 0.022664   | 0.179   | 0.857556   |
   | Shimmer.APQ3  | 32.070932  | 77.159242  | 0.416   | 0.677694   |
   | Shimmer.DDA   | -32.387241 | 77.158814  | -0.420  | 0.674695   |
   | Jitter.RAP    | -5.269544  | 18.834160  | -0.280  | 0.779658   |
   | Jitter.DDP    | 5.249558   | 18.837525  | 0.279   | 0.780510   |
   | Jitter.PPQ5   | -0.074568  | 0.087766   | -0.850  | 0.395592   |
   | Jitter...     | 0.186931   | 0.149561   | 1.250   | 0.211431   |
   | Shimmer.dB.   | -0.172655  | 0.139316   | -1.239  | 0.215315   |

   Mean square error:

   - Formula: $$\text{MSE} = \frac{1}{n} \sum_{i=1}^{n} (y_i - \hat{y}_i)^2$$
   - $\text{MSE}_{\text{train}} = 0.878543102826276$
   - $\text{MSE}_{\text{test}} = 0.935447712156739$

3. The functions where implemented using the following formulas:

   - _Loglikelihood_: $$\log P(y \mid X, \theta, \sigma) = -\frac{n}{2} \log(2\pi) - n \log \sigma - \frac{1}{2\sigma^2} \|y - X\theta\|^2$$
   - _Ridge_: $$\mathcal{L}_{\text{ridge}}(\theta, \sigma, \lambda) = - \log P(T | \theta, \sigma) + \lambda \sum_{j=1}^{p} \theta_j^2$$
   - _RidgeOpt_: $$\hat{\theta}, \hat{\sigma} = \arg \min_{\theta, \sigma} \mathcal{L}_{\text{ridge}}(\theta, \sigma, \lambda)$$
   - _DF_: $$\text{df}(\lambda) = \text{tr}\left( X \left( X^T X + \lambda I \right)^{-1} X^T \right)$$

4. Optimal $\bold{\theta}$ for $\lambda \in \{1,100,1000\}$:

   - $\lambda = 1$:
     - $\text{MSE}_{\text{train}} = 0.878627075979604$:
     - $\text{MSE}_{\text{test}} = 0.93499698041696$:
     - $df = 13.8607362829965$
   - $\lambda = 100$:
     - $\text{MSE}_{\text{train}} = 0.884410431119223$
     - $\text{MSE}_{\text{test}} = 0.932331719427938$
     - $df = 9.92488712829542$
   - $\lambda = 1000$:
     - $\text{MSE}_{\text{train}} = 0.921107873074395$
     - $\text{MSE}_{\text{test}} = 0.953955470516858$
     - $df = 5.6439254878463$

   $\lambda = 100$ seems to be the most suitable penalty parameter considering
   we are able to drop $df(1) - df(100) \approx 4$ degrees of freedom without
   any significant change in $\text{MSE}_{test}$.

## Assignment 3

1. Probably not very easy to classify due to a lot of overlapping. We can not separate the two classes with a single line.

   ![Plasma Glukos Concentration vs Age](./figures/assignment3-1.png)

2. The probibalistic equation for diabetes:

   $$p(y = 1 \mid \mathbf{x}^*) = g(\mathbf{x}^*, \boldsymbol{\theta}) = \frac{1}{1 + e^{-\boldsymbol{\theta}^\top \mathbf{x}^*}}$$

   Consequently the equation for no diabetes becomes:

   $$p(y = 0 \mid \mathbf{x}^*) = 1 - p(y = 1 \mid \mathbf{x}^*)$$

   We transform the probability into a decision:

   $$
   \hat{y} =
   \begin{cases}
   1 & \text{if } p(y = 1 \mid \mathbf{x}^*) > r \\
   0 & \text{otherwise}
   \end{cases}
   $$

   ![Plasma Glukos Concentration vs Age](./figures/assignment3-2.png)

   $E_{\text{mis}}(r = 0.5) = 0.2630208$

   Comment: Not a very good model since we missclassify every fourth descision. Note: $r = 0.5$ gives the lowest possible missclassification rate.

3. The equation of the decision boundary between the two classes

   $$r = sigm(\mathbf{\theta}^T\mathbf{x}) = \frac{1}{1+e^{-\mathbf{\theta}^T\mathbf{x}}}$$

   which results in

   $$\ln(\frac{r}{1-r}) = \mathbf{\theta}^T\mathbf{x}$$

   We get the following boundry:

   ![Plasma Glukos Concentration vs Age](./figures/assignment3-3.png)

   This does not capture the original data distibution very well.

4. Lower $r$ gives lower risk of missing patient with diabetes as shown in the plots bellow.

   ![Plasma Glukos Concentration vs Age](./figures/assignment3-4-1.png)

   ![Plasma Glukos Concentration vs Age](./figures/assignment3-4-2.png)

5. The model becomes more complex with lower missclassification rate, which would mean that it is better.

   ![Plasma Glukos Concentration vs Age](./figures/assignment3-5.png)

   $E_{\text{miss}}(r=0.5) = 0.2447917$

## Assignment 4

- _Why can it be important to consider various probability thresholds in the
  classification problems, according to the book?_

  - According to the book it is important to consider various probability
    thresholds since, even though the threshold $r = 0.5$ given
    $g(\bold{x}) = p(y=1|\bold{x})$ (the model provides a correct description
    of the real-world class probabilities) will give the smallest number of
    misslcassifications on average and therefore minimise the
    _misclassification rate_, it may not allways be the most important aspect
    of the classifier. There exist classification problems that are asymmetric
    (it is more important to cerrectly predict some classes than others) or
    imbalanced (the classes occur with very different frequencies). For such
    problems, minimising the misclassification rate might not lead to a desired
    performance. [p. 50]

- _What ways of collecting correct values of the target variable for the
  supervised learning problems are mentioned in the book?_

  - There are several ways of collecting correct values of the target variable:
    - Manual Labeling: Just a simple matter of recording $\bold{x}$ and $y$. [p. 14]
    - Expert Labeling: In some applications, the output $y$ has to be created by
      labelling of the training data inputs $\bold{x}$ by a domain expert. [p. 14]

- _How can one express the cost function of the linear regression in the matrix
  form, according to the book?_

  - According to the book the cost function of a linear regression model

    $$\mathbf{y=X\theta + \epsilon}$$

    can in matrix for be expressed as

    $$J(\theta) = \frac{1}{n} \sum_{i=1}^{n} \left( \hat{y}(\mathbf{x_i;\theta}) - y_i \right)^2 = \frac{1}{n} \| \mathbf{\hat{y} - y} \|^2_2 = \frac{1}{n} \| \mathbf{X \theta - y} \|^2_2 = \frac{1}{n} \| \mathbf{\epsilon} \|^2_2$$

    where $\| \cdot \|_2$ denotes the usual Euclidean vector norm and $\| \cdot \|^2_2$ its square. [p. 41]
